> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gmicloud.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Update template



## OpenAPI

````yaml /api-spec/service_api.yaml put /v1/templates/{id}
openapi: 3.0.1
info:
  contact:
    email: support@gmicloud.ai
  description: Cluster Engine API spec
  title: Cluster Engine API
  version: 2.4.0
servers:
  - url: https://console.gmicloud.ai/api
security:
  - bearerAuth: []
tags:
  - name: containers
    description: >-
      GMI Container management APIs for creating, managing, and monitoring
      containerized applications.
  - name: templates
    description: >-
      GMI template management APIs for creating and managing reusable container
      template.
  - name: baremetals
    description: >-
      GMI Bare metal management APIs for provisioning, configuring, and
      controlling physical server nodes. Handles server lifecycle management,
      hardware inventory, and status monitoring.
  - name: images
    description: GMI Image management APIs for query OS images.
  - name: elastic-ips
    description: >-
      GMI Elastic IP address management APIs for allocating, associating, and
      managing public IP addresses.
paths:
  /v1/templates/{id}:
    put:
      tags:
        - templates
      summary: Update template
      operationId: UpdateTemplates
      parameters:
        - in: path
          name: id
          required: true
          schema:
            format: uuid
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/template'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  modified:
                    type: string
                type: object
          description: successful
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
        '409':
          $ref: '#/components/responses/Conflict'
        '500':
          $ref: '#/components/responses/InternalServerError'
        '503':
          $ref: '#/components/responses/ServiceUnavailable'
components:
  schemas:
    template:
      properties:
        credential:
          $ref: '#/components/schemas/credential'
        description:
          default: ''
          maxLength: 4096
          minLength: 0
          type: string
        name:
          $ref: '#/components/schemas/name'
        path:
          format: uri
          maxLength: 253
          pattern: ^\S+$
          type: string
        status:
          default: published
          enum:
            - draft
            - published
            - unpublished
          type: string
      required:
        - name
        - path
      type: object
    credential:
      default:
        secret: ''
        username: ''
      properties:
        secret:
          default: ''
          format: password
          maxLength: 4096
          minLength: 0
          type: string
        username:
          default: ''
          maxLength: 4096
          minLength: 0
          type: string
      type: object
    name:
      maxLength: 255
      pattern: ^([A-Za-z0-9][A-Za-z0-9_\-. ]*)?[A-Za-z0-9]$
      type: string
    error:
      properties:
        code:
          type: integer
          x-go-type-skip-optional-pointer: true
        reason:
          type: string
          x-go-type-skip-optional-pointer: true
      required:
        - reason
      type: object
    errorStatusMessage:
      example:
        code: 0
        group: request
        validationDetail:
          - expression: required
            field: userName
            originalValue: ''
            reason: This field is required.
      properties:
        code:
          description: The substatus error code for the API response.
          type: integer
        group:
          description: >-
            API function group. Will be "request" if there are invalid request
            parameters.
          type: string
        message:
          description: The substatus error message for the API response.
          type: string
        traces:
          description: The original error messages.
          items:
            type: string
          type: array
        validationDetail:
          items:
            $ref: '#/components/schemas/validationDetail'
          type: array
      required:
        - group
        - code
      type: object
    validationDetail:
      example:
        expression: required
        field: userName
        originalValue: ''
        reason: This field is required.
      properties:
        argument:
          description: Data supporting the expression.
          type: string
        expression:
          description: The form of violation.
          type: string
        field:
          description: The field of the request data.
          type: string
        originalValue:
          description: The original value from the request.
          type: string
        reason:
          description: The reason for the validation error.
          type: string
      type: object
  responses:
    BadRequest:
      content:
        application/json:
          example:
            reason: resources.CPU is a required property
          schema:
            oneOf:
              - $ref: '#/components/schemas/error'
              - $ref: '#/components/schemas/errorStatusMessage'
      description: bad request
    Unauthorized:
      content:
        application/json:
          examples:
            Expired access token.:
              summary: Expired access token.
              value:
                code: 1
                group: auth_verify
                message: Expired access token.
            Invalid access token.:
              summary: Invalid access token.
              value:
                code: 0
                group: auth_verify
                message: Invalid access token.
          schema:
            $ref: '#/components/schemas/errorStatusMessage'
      description: Authentication information is missing or invalid
      headers:
        WWW_Authenticate:
          schema:
            type: string
    NotFound:
      content:
        application/json:
          example:
            reason: resource 12345678-1234-2234-3234-xxxxxxxxxxxxxx was not found
          schema:
            $ref: '#/components/schemas/error'
      description: The specified resource was not found
    Conflict:
      content:
        application/json:
          example:
            reason: timestamp mismatched
          schema:
            $ref: '#/components/schemas/error'
      description: request failed due to a conflict create or update
    InternalServerError:
      content:
        application/json:
          example:
            reason: An error occurred in the kubernetes cluster
          schema:
            $ref: '#/components/schemas/error'
      description: Internal Server Error
    ServiceUnavailable:
      content:
        application/json:
          example:
            reason: database is unavailable
          schema:
            $ref: '#/components/schemas/error'
      description: a dependent service is unavailable
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      scheme: bearer
      type: http

````